commit c59d1e73a617277fea13e785bb0e3f8c1df6ffc4
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Tue Aug 23 22:16:14 2022 +0200

    Fortran: improve error recovery while simplifying size of bad array [PR103694]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/103694
            * simplify.c (simplify_size): The size expression of an array cannot
            be simplified if an error occurs while resolving the array spec.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/103694
            * gfortran.dg/pr103694.f90: New test.
    
    (cherry picked from commit 55d8c5409325001c89c35c3d04d425dec9127146)

diff --git a/gcc/fortran/simplify.c b/gcc/fortran/simplify.c
index 149353ef784..a265748efd0 100644
--- a/gcc/fortran/simplify.c
+++ b/gcc/fortran/simplify.c
@@ -7387,8 +7387,9 @@ simplify_size (gfc_expr *array, gfc_expr *dim, int k)
     }
 
   for (ref = array->ref; ref; ref = ref->next)
-    if (ref->type == REF_ARRAY && ref->u.ar.as)
-      gfc_resolve_array_spec (ref->u.ar.as, 0);
+    if (ref->type == REF_ARRAY && ref->u.ar.as
+	&& !gfc_resolve_array_spec (ref->u.ar.as, 0))
+      return NULL;
 
   if (dim == NULL)
     {
diff --git a/gcc/testsuite/gfortran.dg/pr103694.f90 b/gcc/testsuite/gfortran.dg/pr103694.f90
new file mode 100644
index 00000000000..3ed8b2088da
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr103694.f90
@@ -0,0 +1,11 @@
+! { dg-do compile }
+! PR fortran/103694 - ICE in gfc_conv_expr_op
+! Contributed by G.Steinmetz
+
+subroutine s
+  type t
+     integer :: a(2)
+  end type
+  type(t) :: x((0.)/0)
+  integer :: n = size(x(1)%a) ! { dg-error "does not reduce to a constant expression" }
+end

